#include "music.h"

bool
music_init(Music* self, const char* path)
{
	self->chunk = Mix_LoadMUS(path);

	if (!self->chunk)
	{
		printf(STRING_SDL_MIXER_MUSIC_ERROR, path, Mix_GetError());
		return false;
	}

	printf(STRING_SDL_MIXER_MUSIC_SUCCESS, path);

	self->isInit = true;
	
	return true;
}

void
music_free(Music* self)
{
	if (self->isInit)
	{
		Mix_FreeMusic(self->chunk);
		self->isInit = false;
	}
}

void
music_play(Music* self, bool isLoop)
{
	if (isLoop)
		Mix_PlayMusic(self->chunk, -1);
	else
		Mix_PlayMusic(self->chunk, 0);
}

void
music_resume(void)
{
	Mix_ResumeMusic();
}

void
music_pause(void)
{
	Mix_PauseMusic();
}

void
music_stop(void)
{
	Mix_HaltMusic();
}

bool
music_is_playing_check(void)
{
	return Mix_PlayingMusic();
}
