#pragma once

#define SDL_MAIN_HANDLED

#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_mixer.h>
#include <SDL2/SDL_ttf.h>
#include "../COMMON.h"

#define STRING_SDL2_VIDEO_ERROR "[ERROR] Unable to initialize SDL2 (Video): %s\n", SDL_GetError()
#define STRING_SDL2_VIDEO_INIT "[INFO] Initialized SDL2 (Video)\n"
#define STRING_SDL2_TIMER_ERROR "[ERROR] Unable to initialize SDL2 (Timer): %s\n", SDL_GetError()
#define STRING_SDL2_TIMER_INIT "[INFO] Initialized SDL2 (Timer)\n"
#define STRING_SDL_IMAGE_ERROR "[ERROR] Unable to initialize SDL_image: %s\n", IMG_GetError()
#define STRING_SDL_IMAGE_INIT "[INFO] Initialized SDL_image\n"
#define STRING_SDL_MIXER_ERROR "[ERROR] Unable to initialize SDL_mixer: %s\n", Mix_GetError()
#define STRING_SDL_MIXER_INIT "[INFO] Initialized SDL_mixer\n"
#define STRING_SDL_TTF_ERROR "[ERROR] Unable to initialize SDL_ttf: %s\n", TTF_GetError()
#define STRING_SDL_TTF_INIT "[INFO] Initialized SDL_ttf\n"
#define STRING_SDL2_QUIT "[INFO] Quitting SDL2\n"

#define MIX_FREQUENCY 44100
#define MIX_SAMPLE_SIZE 2048

#define IMG_FLAGS (IMG_INIT_PNG)

void sdl_init(void);
void sdl_quit(void);
