#include "component_food.h"

void
component_food_tick(ComponentFood* self, ECS* ecs)
{
	self->value = CLAMP(self->value, 0, self->max);

	if (self->value == self->max)
	{
		if (!self->isJustFull)
		{
			sound_play(&ecs->resources->sounds[SOUND_CANT_CARRY]);
			self->isJustFull = true;
		}
	}
	else
		self->isJustFull = false;
}

void 
component_food_init(ComponentFood* self, ECS* ecs, s32 value, s32 max, s32 multiplier)
{
	self->value = value;
	self->max = max;
	self->multiplier = multiplier;
}
