#pragma once

#include "../visual/component_texture_quad.h"
#include "../physics/component_physics.h"

typedef struct ComponentGameObject
{
	Component component;
} ComponentGameObject;

void
component_game_object_init
(
	ComponentGameObject* self, 
	ECS* ecs,
	Texture* texture, 
	RendererBuffer buffer,
	Origin origin,
	vec2 size, 
	vec3 position
);

void component_game_object_add(ComponentGameObject* self, ECS* ecs);
void component_game_object_tick(ComponentGameObject* self, ECS* ecs);

#define COMPONENT_GAME_OBJECT_DEPENDENCY_COUNT 2
static const ComponentType COMPONENT_GAME_OBJECT_DEPENDENCIES[COMPONENT_GAME_OBJECT_DEPENDENCY_COUNT] = 
{
	COMPONENT_PHYSICS,
	COMPONENT_TEXTURE_QUAD,
};

static const ComponentInfo COMPONENT_GAME_OBJECT_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_game_object_add, 
			NULL,
			(ECSFunction)component_game_object_tick, 
			NULL,
			NULL
		}
	},
	.type = COMPONENT_GAME_OBJECT,
	.size = sizeof(ComponentGameObject)
};
