#pragma once

#include "component/animation/component_animation.h"
#include "component/animation/component_animation_player.h"
#include "component/animation/component_animation_target.h"
#include "component/game/component_collect.h"
#include "component/game/component_collectible.h"
#include "component/game/component_collide_slow.h"
#include "component/game/component_food.h"
#include "component/game/component_threshold.h"
#include "component/game/component_game_object.h"
#include "component/game/component_homing.h"
#include "component/game/component_levitate.h"
#include "component/game/component_player_control.h"
#include "component/game/component_power.h"
#include "component/game/component_solid.h"
#include "component/game/component_stamina.h"
#include "component/game/component_take_food.h"
#include "component/game/component_stage.h"
#include "component/game/component_plane_object.h"
#include "component/game/component_world_object.h"
#include "component/physics/component_circle_collider.h"
#include "component/physics/component_copy_mouse_position.h"
#include "component/physics/component_physics.h"
#include "component/ui/component_button.h"
#include "component/utility/component_counter.h"
#include "component/utility/component_timer.h"
#include "component/utility/component_delete_on_timer.h"
#include "component/visual/component_atlas.h"
#include "component/visual/component_dialogue.h"
#include "component/visual/component_drop_shadow.h"
#include "component/visual/component_color_change.h"
#include "component/visual/component_color_match.h"
#include "component/visual/component_scale_value.h"
#include "component/visual/component_pulsate.h"
#include "component/visual/component_rotate.h"
#include "component/visual/component_text.h"
#include "component/visual/component_texture_quad.h"
#include "component/visual/component_value_text.h"

#include "../input/control.h"
#include "../render/postprocessing.h"
#include "../resource/resources.h"

static const struct ComponentInfo COMPONENT_INFO[COMPONENT_COUNT] = 
{
	/* Utility */
	COMPONENT_TIMER_INFO,
	COMPONENT_COUNTER_INFO,
	COMPONENT_DELETE_ON_TIMER_INFO,
	/* Physics */
	COMPONENT_PHYSICS_INFO,
	COMPONENT_COPY_MOUSE_POSITION_INFO,
	COMPONENT_CIRCLE_COLLIDER_INFO,
	/* Game */
	COMPONENT_GAME_OBJECT_INFO,
	COMPONENT_PLANE_OBJECT_INFO,
	COMPONENT_WORLD_OBJECT_INFO,
	COMPONENT_SOLID_INFO,
	COMPONENT_LEVITATE_INFO,
	COMPONENT_COLLIDE_SLOW_INFO,
	COMPONENT_COLLECTIBLE_INFO,
	COMPONENT_COLLECT_INFO,
	COMPONENT_HOMING_INFO,
	COMPONENT_FOOD_INFO,
	COMPONENT_THRESHOLD_INFO,
	COMPONENT_TAKE_FOOD_INFO,
	COMPONENT_STAGE_INFO,
	COMPONENT_STAMINA_INFO,
	COMPONENT_POWER_INFO,
	COMPONENT_PLAYER_CONTROL_INFO,
	/* Animation */
	COMPONENT_ANIMATION_INFO,
	COMPONENT_ANIMATION_PLAYER_INFO,
	COMPONENT_ANIMATION_TARGET_INFO,
	/* UI */
	COMPONENT_BUTTON_INFO,
	/* Visual */
	COMPONENT_DROP_SHADOW_INFO,
	COMPONENT_TEXTURE_QUAD_INFO,
	COMPONENT_TEXT_INFO,
	COMPONENT_DIALOGUE_INFO,
	COMPONENT_VALUE_TEXT_INFO,
	COMPONENT_ATLAS_INFO,
	COMPONENT_COLOR_CHANGE_INFO,
	COMPONENT_COLOR_MATCH_INFO,
	COMPONENT_SCALE_VALUE_INFO,
	COMPONENT_ROTATE_INFO,
	COMPONENT_PULSATE_INFO
};

void ecs_tick(ECS* self);
void ecs_update(ECS* self);
void ecs_draw(ECS* self);
void ecs_init(ECS* self, Renderer* renderer, Control* control, Input* input, Resources* resources, Postprocessing* postprocessing);
void ecs_clear(ECS* self);
void ecs_free(ECS* self);
