#include "entity_collectible.h"

EntityID
entity_collectible_add(ECS* ecs, const vec3 position, CollectibleType type)
{
	EntityID id;
	ComponentPhysics* physics;
	vec3 smokePosition;

	id = ecs_entity_add(ecs);

	ecs_components_add(ecs, ENTITY_COLLECTIBLE_DEPENDENCIES, ENTITY_COLLECTIBLE_DEPENDENCY_COUNT, id);
	
	component_collectible_init
	(
		ecs_component_get(ecs, COMPONENT_COLLECTIBLE, id), 
		ecs, 
		&ecs->resources->textures[TEXTURE_COLLECTIBLE], 
		ENTITY_COLLECTIBLE_SIZE, 
		position,
		type
	);

	component_atlas_init
	(
		ecs_component_get(ecs, COMPONENT_ATLAS, id),
		ecs,
		ENTITY_COLLECTIBLE_ATLAS_FRAME_SIZE,
		ENTITY_COLLECTIBLE_ATLAS_SIZE,
		(u32)type
	);
	
	physics = ecs_component_get(ecs, COMPONENT_PHYSICS, id);

	glm_vec3_copy(physics->position, smokePosition);

	smokePosition[2] += ENTITY_COLLECTIBLE_SMOKE_Z_OFFSET;

	entity_smoke_add
	(
		ecs,
		smokePosition
	);

	return id;
}
