#pragma once

#include "../../component/game/component_collectible.h"
#include "../../component/visual/component_rotate.h"
#include "../../component/visual/component_atlas.h"

#include "entity_smoke.h"

static const vec2 ENTITY_COLLECTIBLE_SIZE = {128.0f, 128.0f};
static const ivec2 ENTITY_COLLECTIBLE_ATLAS_FRAME_SIZE = {32, 32};
static const ivec2 ENTITY_COLLECTIBLE_ATLAS_SIZE = {1, 6};
static const f32 ENTITY_COLLECTIBLE_SMOKE_Z_OFFSET = 0.01f;

#define ENTITY_COLLECTIBLE_DEPENDENCY_COUNT 3
static const ComponentType ENTITY_COLLECTIBLE_DEPENDENCIES[ENTITY_COLLECTIBLE_DEPENDENCY_COUNT] =
{
	COMPONENT_ATLAS,
	COMPONENT_COLLECTIBLE,
	COMPONENT_ROTATE
};

EntityID entity_collectible_add(ECS* ecs, const vec3 position, CollectibleType type);
