#pragma once

#include "../../component/animation/component_animation.h"
#include "../../component/animation/component_animation_player.h"
#include "../../component/game/component_player_control.h"
#include "../../component/visual/component_atlas.h"
#include "../../component/visual/component_color_change.h"
#include "../../component/game/component_food.h"
#include "../../component/game/component_power.h"
#include "../../component/game/component_collect.h"
#include "../../component/game/component_stamina.h"
#include "../../component/game/component_world_object.h"

static const TextureType PLAYER_TEXTURE = TEXTURE_PLAYER;
static const vec2 PLAYER_SIZE = {384.0f, 256.0f};
static const f32 PLAYER_HEIGHT_OFFSET = 0.0f;
static const f32 PLAYER_RADIUS = 128.0f;
static const f32 PLAYER_STAMINA_MAX = 100.0f;
static const f32 PLAYER_STAMINA_GAIN = 0.1f;
static const f32 PLAYER_POWER_MAX = 100.0f;
static const f32 PLAYER_POWER_GAIN = 0.01f;
static const f32 PLAYER_COLLECT_RADIUS = 250.0f;

static const ivec2 PLAYER_ATLAS_FRAME_SIZE = {96, 64};
static const ivec2 PLAYER_ATLAS_SIZE = {4, 5};
static const s32 PLAYER_ATLAS_INDEX = 0;
static const f32 PLAYER_ANGLE = PI_HALF;
static const s32 PLAYER_FOOD_MAX = 25;
static const s32 PLAYER_FOOD_MULTIPLIER = 1;

#define ENTITY_PLAYER_DEPENDENCY_COUNT 11
static const ComponentType ENTITY_PLAYER_DEPENDENCIES[ENTITY_PLAYER_DEPENDENCY_COUNT] =
{
	COMPONENT_WORLD_OBJECT,
	COMPONENT_ATLAS,
	COMPONENT_COLLECT,
	COMPONENT_FOOD,
	COMPONENT_POWER,
	COMPONENT_STAMINA,
	COMPONENT_PLAYER_CONTROL,
	COMPONENT_ANIMATION,
	COMPONENT_ANIMATION_PLAYER,
	COMPONENT_COLOR_CHANGE
};

EntityID entity_player_add(ECS* ecs, const vec3 position);
