#include "entity_smoke_big.h"

EntityID
entity_smoke_big_add(ECS* ecs, vec3 position)
{
	EntityID id;
	f32 angle;

	id = entity_sprite_atlas_add
	(
		ecs,
		&ecs->resources->textures[TEXTURE_SMOKE],
		RENDERER_BUFFER_WORLD,
		ORIGIN_CENTER,
		ENTITY_SMOKE_BIG_SIZE,
		position,
		ENTITY_SMOKE_ATLAS_FRAME_SIZE,
		ENTITY_SMOKE_ATLAS_SIZE,
		0
	);

	ecs_components_add(ecs, ENTITY_SMOKE_DEPENDENCIES, ENTITY_SMOKE_DEPENDENCY_COUNT, id);
	
	component_animation_init
	(
		ecs_component_get(ecs, COMPONENT_ANIMATION, id),
		ecs,
		&ENTITY_SMOKE_ANIMATION
	);

	component_delete_on_timer_init
	(
		ecs_component_get(ecs, COMPONENT_DELETE_ON_TIMER, id),
		ecs,
		ENTITY_SMOKE_TIMER
	);

	return id;
}
