#include "entity_target.h"

EntityID
entity_target_add(ECS* ecs, const vec3 position, u32 threshold, u32 stage, EntityID playerID)
{
	EntityID id;

	id = ecs_entity_add(ecs);

	ecs_components_add(ecs, ENTITY_TARGET_DEPENDENCIES, ENTITY_TARGET_DEPENDENCY_COUNT, id);
	
	component_world_object_init
	(
		ecs_component_get(ecs, COMPONENT_WORLD_OBJECT, id), 
		ecs, 
		&ecs->resources->textures[TEXTURE_TARGET], 
		TARGET_SIZE, 
		position,
		TARGET_HEIGHT_OFFSET,
		TARGET_RADIUS,
		true
	);

	component_atlas_init
	(
		ecs_component_get(ecs, COMPONENT_ATLAS, id),
		ecs,
		TARGET_ATLAS_FRAME_SIZE,
		TARGET_ATLAS_SIZE,
		0
	);

	component_threshold_init
	(
		ecs_component_get(ecs, COMPONENT_THRESHOLD, id),
		ecs,
		threshold
	);

	component_stage_init
	(
		ecs_component_get(ecs, COMPONENT_STAGE, id),
		ecs,
		stage
	);

	component_animation_target_init
	(
		ecs_component_get(ecs, COMPONENT_ANIMATION_TARGET, id),
		ecs,
		ANIMATION_TARGET_IDLE_STAGE_ONE,
		playerID
	);

	component_food_init
	(
		ecs_component_get(ecs, COMPONENT_FOOD, id),
		ecs,
		0,
		TARGET_FOOD_MAX,
		TARGET_FOOD_MULTIPLIER
	);

	return id;
}
