#include "entity_logo.h"

EntityID
entity_logo_add(ECS* ecs, vec3 position)
{
	EntityID id;

	id = entity_sprite_add
	(
		ecs,
		&ecs->resources->textures[TEXTURE_LOGO],
		RENDERER_BUFFER_UI,
		ORIGIN_CENTER,
		ENTITY_LOGO_SIZE,
		position
	);

	ecs_components_add(ecs, ENTITY_LOGO_DEPENDENCIES, ENTITY_LOGO_DEPENDENCY_COUNT, id);

	component_pulsate_init
	(
		ecs_component_get(ecs, COMPONENT_PULSATE, id),
		ecs,
		ENTITY_LOGO_PULSATE_MIN_SCALE,
		ENTITY_LOGO_PULSATE_MAX_SCALE,
		ENTITY_LOGO_PULSATE_FREQUENCY
	);

	return id;
}
