#include "entity_dialogue.h"

EntityID
entity_dialogue_add
(
	ECS* ecs, 
	Font* font, 
	RendererBuffer buffer, 
	const char* string, 
	const vec3 position,
	u32 wrap,
	u32 speed
)
{
	EntityID id;

	id = ecs_entity_add(ecs);

	ecs_components_add(ecs, ENTITY_DIALOGUE_DEPENDENCIES, ENTITY_DIALOGUE_DEPENDENCY_COUNT, id);
	
	component_text_init
	(
		ecs_component_get(ecs, COMPONENT_TEXT, id), 
		ecs, 
		font,
		buffer,
		string,
		position,
		strlen(string),
		wrap
	);

	component_dialogue_init
	(
		ecs_component_get(ecs, COMPONENT_DIALOGUE, id),
		ecs,
		string,
		speed
	);

	return id;
}
