#include "entity_glyph.h"

EntityID
entity_glyph_add
(
	ECS* ecs, 
	Texture* texture,
	RendererBuffer buffer, 
	const vec2 size,
	const vec3 position,
	const vec4 color,
	const vec4 dropShadowColor,
	const vec2 dropShadowOffset
)
{
	EntityID id;

	id = ecs_entity_add(ecs);

	ecs_components_add(ecs, ENTITY_GLYPH_DEPENDENCIES, ENTITY_GLYPH_DEPENDENCY_COUNT, id);
	
	component_texture_quad_init
	(
		ecs_component_get(ecs, COMPONENT_TEXTURE_QUAD, id), 
		ecs, 
		texture, 
		COMPONENT_TEXTURE_QUAD_FLIP_DEFAULT,
		COMPONENT_TEXTURE_QUAD_ORIGIN_DEFAULT,
		buffer,
		COMPONENT_TEXTURE_QUAD_ROTATION_DEFAULT,
		(f32*)size, 
		(f32*)COMPONENT_TEXTURE_QUAD_SCALE_DEFAULT,
		(f32*)COMPONENT_TEXTURE_QUAD_UV_MIN_DEFAULT,
		(f32*)COMPONENT_TEXTURE_QUAD_UV_MAX_DEFAULT,
		(f32*)COMPONENT_TEXTURE_QUAD_OFFSET_DEFAULT,
		(f32*)position,
		(f32*)color
	);

	component_drop_shadow_init
	(
		ecs_component_get(ecs, COMPONENT_DROP_SHADOW, id), 
		ecs, 
		(f32*)dropShadowColor,
		(f32*)dropShadowOffset
	);

	return id;
}
