#pragma once

#include "input.h"

#define CONTROL_COUNT CONTROL_MUTE + 1
typedef enum ControlType
{
	CONTROL_NONE,
	CONTROL_UP,
	CONTROL_DOWN,
	CONTROL_LEFT,
	CONTROL_RIGHT,
	CONTROL_ACTION_PRIMARY,
	CONTROL_ACTION_SECONDARY,
	CONTROL_ACTION_TERTIARY,
	CONTROL_INVIGORATE,
	CONTROL_EXTEND,
	CONTROL_FORESIGHT,
	CONTROL_CANCEL,
	CONTROL_MAGNET,
	CONTROL_PAUSE,
	CONTROL_RETRY,
	CONTROL_ESCAPE,
	CONTROL_MUTE
} ControlType;

typedef struct Control
{
	bool current[CONTROL_COUNT];
	bool previous[CONTROL_COUNT];
} Control;

void control_tick(Control* control, Input* input);
bool control_pressed(Control* control, ControlType type);
bool control_held(Control* control, ControlType type);
bool control_released(Control* control, ControlType type);
void control_clear(Control* control);
