#include "resource_texture.h"

bool
resource_texture_init(Resources* self, TextureType type)
{
	if (!texture_from_path_init(&self->textures[type], TEXTURE_PATHS[type]))
	{
		printf(STRING_RESOURCE_TEXTURE_ERROR, TEXTURE_PATHS[type]);
		return false;
	}

	printf(STRING_RESOURCE_TEXTURE_INIT, TEXTURE_PATHS[type]);

	return true;
}

void
resource_texture_free(Resources* self, TextureType type)
{
	if (self->textures[type].isInit)
	{
		texture_free(&self->textures[type]);

		printf(STRING_RESOURCE_TEXTURE_FREE, TEXTURE_PATHS[type]);
	}
}
